## turtlearena-0.6.1-0-src.tar.bz2

=== Makefile ===
#
# Turtle Arena packaging system
#
# See engine/Makefile for building the game.
#

COMPILE_PLATFORM=$(shell uname|sed -e s/_.*//|tr '[:upper:]' '[:lower:]'|sed -e 's/\//_/g')

COMPILE_ARCH=$(shell uname -m | sed -e s/i.86/i386/)

ifeq ($(COMPILE_PLATFORM),sunos)
  # Solaris uname and GNU uname differ
  COMPILE_ARCH=$(shell uname -p | sed -e s/i.86/i386/)
endif
ifeq ($(COMPILE_PLATFORM),darwin)
  # Apple does some things a little differently...
  COMPILE_ARCH=$(shell uname -p | sed -e s/i.86/i386/)
endif

ifeq ($(COMPILE_PLATFORM),mingw32)
  ifeq ($(COMPILE_ARCH),i386)
    COMPILE_ARCH=x86
  endif
  ifeq ($(COMPILE_ARCH),x86_64)
    COMPILE_ARCH=x64
  endif
endif

ifndef MINGWMAKE
ifeq ($(COMPILE_PLATFORM),mingw32)
MINGWMAKE=make ARCH=x86
else
MINGWMAKE=exec engine/cross-make-mingw.sh
endif
endif

ifndef MINGW64MAKE
ifeq ($(COMPILE_PLATFORM),mingw32)
MINGW64MAKE=make ARCH=x64
else
MINGW64MAKE=exec engine/cross-make-mingw64.sh
endif
endif

# Directory to put the files for release
ifndef INSTALLDIR
INSTALLDIR=install
endif

# Directory containing base/assets*.pk3
ifndef DATADIR
DATADIR=install
endif

# These currently only effect zip/full-source name
ifndef GAMENAME
GAMENAME=turtlearena
endif
ifndef VERSION
VERSION=0.6.1
endif
ifndef RELEASE
RELEASE=0
endif

# Used for zip directory name and full source archive name
ifndef NAME
NAME=$(GAMENAME)-$(VERSION)-$(RELEASE)
endif

#############################################################################
#
# If you require a different configuration from the defaults below, create a
# new file named "Makefile.local" in the same directory as this file and define
# your parameters there. This allows you to change configuration without
# causing problems with keeping up to date with the repository.
#
#############################################################################
-include Makefile.local

ifndef PLATFORM
PLATFORM=$(COMPILE_PLATFORM)
endif
export PLATFORM

ifeq ($(COMPILE_ARCH),powerpc)
  COMPILE_ARCH=ppc
endif
ifeq ($(COMPILE_ARCH),powerpc64)
  COMPILE_ARCH=ppc64
endif

ifndef ARCH
ARCH=$(COMPILE_ARCH)
endif
export ARCH

ifneq ($(PLATFORM),$(COMPILE_PLATFORM))
  CROSS_COMPILING=1
else
  CROSS_COMPILING=0

  ifneq ($(ARCH),$(COMPILE_ARCH))
    CROSS_COMPILING=1
  endif
endif
export CROSS_COMPILING

ifeq ($(V),1)
echo_cmd=@:
Q=
else
echo_cmd=@echo
Q=@
endif

ifndef WIN64
WIN64=0
ifeq ($(ARCH),x86_64)
	WIN64=1
endif
ifeq ($(ARCH),x64)
	WIN64=1
endif
endif

ifndef JOBS
JOBS=1
endif

ifndef BUILD_FINAL
BUILD_FINAL=1
endif


#
# Misc
#
default:
	@echo "This is the game's packaging makefile;"
	@echo "Run 'make -C engine' to build the game, or 'make help' for how to build packages"

help:
	@echo "Usage;"
	@echo "  Run 'make packages' to build all packages."
	@echo "  Run 'make clean' to delete all packages."
	@echo "  Run 'make *-clean' to delete a single package type"
	@echo "          (where * is dist, zip, etc. e.g. dist-clean)."
	@echo "  Run 'make engine-dist' to create engine source code tarball."
	@echo "  Run 'make dist' to create engine+data source tarball."
	@echo "  Run 'make distdata' to create engine+data source tarball,"
	@echo "          plus data 'base' directory."
	@echo "  Run 'make zip' to create portable install for zip archive distribution."
	@echo "  Run 'make nsis' to create win32 NSIS installer."
	@echo "  Run 'make nsis64' to create win64 NSIS installer."
	@echo "  Run 'make loki' to create linux loki-setup installer."
	@echo "  Run 'make deb' to create debian packages."

packages: dist zip nsis nsis64 loki deb

clean: dist-clean zip-clean nsis-clean loki-clean deb-clean

#
# QVMs
#
qvms:
	$(MAKE) -C engine BUILD_GAME_SO=0 BUILD_SERVER=0 BUILD_CLIENT=0 BUILD_GAME_QVM=1 BUILD_FINAL=$(BUILD_FINAL) --jobs=$(JOBS)

qvms-clean:
	$(MAKE) -C engine clean BUILD_GAME_SO=0 BUILD_SERVER=0 BUILD_CLIENT=0 BUILD_GAME_QVM=1 --jobs=$(JOBS)

#
# Asset packages (pk3 files)
#
assets: $(DATADIR)/base/assets0.pk3 $(DATADIR)/base/assets1-qvms.pk3 $(DATADIR)/base/assets2-music.pk3 $(DATADIR)/base/assets3-game-patch.pk3

assets-clean: qvms-clean
	rm -fr $(DATADIR)/base/

$(DATADIR)/base/assets0.pk3:
	$(Q)echo "  Coping base data (temporary files)..."
	@if [ -d base/.svn ]; then \
		echo "  NOTE: Using data files from svn, unversioned files/changes not included."; \
		mkdir -p $(DATADIR)/base; \
		rm -fr $(DATADIR)/base/assets0; \
		svn export base $(DATADIR)/base/assets0; \
	else \
		mkdir -p $(DATADIR)/base/assets0; \
		cp -r base/* $(DATADIR)/base/assets0; \
	fi
	$(Q)echo "  Removing unneeded temporary files..."
	$(Q)rm -f $(DATADIR)/base/assets0/*.so
	$(Q)rm -f $(DATADIR)/base/assets0/*.dll
	$(Q)rm -f $(DATADIR)/base/assets0/*.pk3
	$(Q)rm -f $(DATADIR)/base/assets0/*.zip
	$(Q)rm -rf $(DATADIR)/base/assets0/vm/ # qvms are stored in assets1-qvms.pk3
	$(Q)rm -rf $(DATADIR)/base/assets0/music/ # music is stored in assets2-music.pk3
	$(Q)echo "  Zipping assets..."
	$(Q)cd $(DATADIR)/base/assets0/ && zip -qmr ../assets0.pk3 .
	$(Q)rm -r $(DATADIR)/base/assets0/
#
# You may need to update the checksum for assets0.pk3 in engine/code/qcommon/files.c
#    to play on pure servers.
#

$(DATADIR)/base/assets1-qvms.pk3:
	$(Q)echo "Get assets1-qvms.pk3 from Turtle Arena 0.6!"

$(DATADIR)/base/assets2-music.pk3:
	$(Q)echo "  Coping music files (temporary files)..."
	@if [ -d base/.svn ]; then \
		echo "  NOTE: Using music files from svn, unversioned files/changes not included."; \
		mkdir -p $(DATADIR)/base/assets2; \
		rm -fr $(DATADIR)/base/assets2/music; \
		svn export base/music $(DATADIR)/base/assets2/music; \
	else \
		mkdir -p $(DATADIR)/base/assets0/music; \
		cp -r base/music/* $(DATADIR)/base/assets0/music; \
	fi
	$(Q)echo "  Zipping assets..."
	$(Q)cd $(DATADIR)/base/assets2/ && zip -qmr ../assets2-music.pk3 .
	$(Q)rm -r $(DATADIR)/base/assets2/

$(DATADIR)/base/assets3-game-patch.pk3: qvms
	$(Q)mkdir -p $(DATADIR)/base/assets3/vm
	$(Q)cp engine/build/release-$(COMPILE_PLATFORM)-$(COMPILE_ARCH)/base/vm/qagame.qvm $(DATADIR)/base/assets3/vm
	$(Q)cd $(DATADIR)/base/assets3/ && zip -qmr ../assets3-game-patch.pk3 .
	$(Q)rm -r $(DATADIR)/base/assets3/


#
# Create portable zip for windows x86/x64 and linux i386/x86_64
#
zip: assets
	$(Q)mkdir -p $(INSTALLDIR)/$(NAME)/base/
	$(Q)cp $(INSTALLDIR)/base/*.pk3 $(INSTALLDIR)/$(NAME)/base/
	$(Q)cp INSTALLER_README.txt $(INSTALLDIR)/$(NAME)/README.txt
	$(Q)cp GPL-2.txt $(INSTALLDIR)/$(NAME)/
	$(Q)cp CC-BY-SA-3.0.txt $(INSTALLDIR)/$(NAME)/
	$(Q)cp COPYRIGHTS.txt $(INSTALLDIR)/$(NAME)/
	$(Q)cp CREDITS.txt $(INSTALLDIR)/$(NAME)/
	$(Q)todos $(INSTALLDIR)/$(NAME)/*.txt
	$(Q)mkdir -p $(INSTALLDIR)/$(NAME)/settings
	$(Q)echo "yes" > $(INSTALLDIR)/$(NAME)/settings/portable
	@if [ -f engine/misc/nsis/OpenAL32.dll ]; then \
		cp engine/misc/nsis/*.dll $(INSTALLDIR)/$(NAME)/; \
	fi
ifneq ($(PLATFORM),mingw32)
	$(MAKE) -C engine BUILD_FINAL=$(BUILD_FINAL) BUILD_GAME_SO=0 BUILD_GAME_QVM=0 --jobs=$(JOBS)
	$(MAKE) -C engine copyfiles COPYDIR="$(CURDIR)/$(INSTALLDIR)/$(NAME)" BUILD_GAME_SO=0 --jobs=$(JOBS)
ifeq ($(ARCH),x86_64)
	$(MAKE) -C engine ARCH=i386 BUILD_FINAL=$(BUILD_FINAL) BUILD_GAME_SO=0 BUILD_GAME_QVM=0 --jobs=$(JOBS)
	$(MAKE) -C engine ARCH=i386 copyfiles COPYDIR="$(CURDIR)/$(INSTALLDIR)/$(NAME)" BUILD_GAME_SO=0 --jobs=$(JOBS)
endif
endif
	$(MINGWMAKE) -C engine BUILD_FINAL=$(BUILD_FINAL) BUILD_GAME_SO=0 BUILD_GAME_QVM=0 --jobs=$(JOBS)
	$(MINGWMAKE) -C engine copyfiles COPYDIR="$(CURDIR)/$(INSTALLDIR)/$(NAME)" BUILD_GAME_SO=0 --jobs=$(JOBS)
ifeq ($(WIN64),1)
	$(MINGW64MAKE) -C engine BUILD_FINAL=$(BUILD_FINAL) BUILD_GAME_SO=0 BUILD_GAME_QVM=0 --jobs=$(JOBS)
	$(MINGW64MAKE) -C engine copyfiles COPYDIR="$(CURDIR)/$(INSTALLDIR)/$(NAME)" BUILD_GAME_SO=0 --jobs=$(JOBS)
endif

zip-clean:
	$(Q)rm -fr $(INSTALLDIR)/$(NAME)


#
# Create win32 NSIS installer
#
nsis: assets
	$(MINGWMAKE) -C engine installer BUILD_FINAL=$(BUILD_FINAL) BUILD_GAME_SO=0 BUILD_GAME_QVM=0 \
			ASSETPATH="$(CURDIR)/$(DATADIR)/base/" --jobs=$(JOBS)
	$(MINGWMAKE) -C engine/misc/nsis install INSTALLDIR="$(CURDIR)/$(INSTALLDIR)/nsis/"

nsis-clean: assets-clean
	$(Q)rm -fr "$(CURDIR)/$(INSTALLDIR)/nsis"
	$(MINGWMAKE) -C engine/misc/nsis clean --jobs=$(JOBS)

#
# Create win64 NSIS installer
#
nsis64: assets
ifeq ($(WIN64),1)
	$(MINGW64MAKE) -C engine installer BUILD_FINAL=$(BUILD_FINAL) BUILD_GAME_SO=0 BUILD_GAME_QVM=0 \
			ASSETPATH="$(CURDIR)/$(DATADIR)/base/" --jobs=$(JOBS)
	$(MINGW64MAKE) -C engine/misc/nsis install INSTALLDIR="$(CURDIR)/$(INSTALLDIR)/nsis64/"
else
	@echo "Win64 NSIS creation is not supported on this platform."
endif

nsis64-clean: assets-clean
ifeq ($(WIN64),1)
	$(Q)rm -fr "$(CURDIR)/$(INSTALLDIR)/nsis64"
	$(MINGW64MAKE) -C engine/misc/nsis clean --jobs=$(JOBS)
else
	@echo "Win64 NSIS cleaning is not supported on this platform."
endif


#
# Create linux i386/x86_64 installer
#
loki: assets
ifeq ($(PLATFORM),mingw32)
	@echo "Loki setup creation is not supported on this platform."
else
	$(MAKE) -C engine BUILD_FINAL=$(BUILD_FINAL) BUILD_GAME_SO=0 BUILD_GAME_QVM=0 --jobs=$(JOBS)
ifeq ($(ARCH),x86_64)
	$(MAKE) -C engine ARCH=i386 BUILD_FINAL=$(BUILD_FINAL) BUILD_GAME_SO=0 BUILD_GAME_QVM=0 --jobs=$(JOBS)
endif
	$(MAKE) -C engine/misc/setup --jobs=$(JOBS)
	$(Q)mkdir -p $(INSTALLDIR)/loki/
	$(Q)mv engine/misc/setup/*.run $(INSTALLDIR)/loki/
endif

loki-clean:
ifeq ($(PLATFORM),mingw32)
	@echo "Loki setup cleaning is not supported on this platform."
else
	$(MAKE) -C engine/misc/setup clean --jobs=$(JOBS)
	$(Q)rm -rf $(INSTALLDIR)/loki/
endif


#
# Create Debian/Ubuntu packages
# ZTM: TODO: Rewrite deb packaging to use Makefile?
#
deb: assets
ifeq ($(PLATFORM),mingw32)
	@echo "Debian/Ubuntu package creation is not supported on this platform."
else
	exec ./package-deb.sh --installdir $(INSTALLDIR) --datadir $(DATADIR) $(DEBARGS)
endif

deb-clean:
ifeq ($(PLATFORM),mingw32)
	@echo "Debian/Ubuntu package cleaning is not supported on this platform."
else
	$(Q)rm -rf $(INSTALLDIR)/deb/
endif


#
# Create source code tarball
#
engine-dist:
	$(MAKE) -C engine dist BUILD_FINAL=$(BUILD_FINAL)
	$(Q)mkdir -p $(INSTALLDIR)/tarball
	$(Q)mv engine/*.tar.bz2 $(INSTALLDIR)/engine-tarball

engine-dist-clean:
	$(Q)rm -rf $(INSTALLDIR)/engine-tarball/


#
# Create source tarball
#
# Does not include base directory as data is in base/assets.pk3
#   uses a lot less space this way.
dist:
	$(Q)rm -rf $(INSTALLDIR)/$(NAME)-src
	@if [ -d .svn ]; then \
		echo "  NOTE: Using files from svn, unversioned files/changes not included."; \
		mkdir -p $(INSTALLDIR); \
		svn export . $(INSTALLDIR)/$(NAME)-src; \
	else \
		mkdir -p $(INSTALLDIR)/$(NAME)-src; \
		cp -r . $(INSTALLDIR)/$(NAME)-src; \
		rm -fr $(INSTALLDIR)/$(NAME)-src/engine/build; \
	fi
	$(Q)rm -rf $(INSTALLDIR)/$(NAME)-src/base
	$(Q)tar -C $(INSTALLDIR) --owner=root --group=root --force-local -cjf $(INSTALLDIR)/$(NAME)-src.tar.bz2 $(NAME)-src
	$(Q)rm -rf $(INSTALLDIR)/$(NAME)-src

dist-clean:
	$(Q)rm -rf $(INSTALLDIR)/$(NAME)-src/
	$(Q)rm -f $(INSTALLDIR)/$(NAME)-src.tar.bz2

# Include 'base' data directory.
distdata:
	$(Q)rm -rf $(INSTALLDIR)/$(NAME)-src-with-data
	@if [ -d .svn ]; then \
		echo "  NOTE: Using files from svn, unversioned files/changes not included."; \
		mkdir -p $(INSTALLDIR); \
		svn export . $(INSTALLDIR)/$(NAME)-src-with-data; \
	else \
		mkdir -p $(INSTALLDIR)/$(NAME)-src-with-data; \
		cp -r . $(INSTALLDIR)/$(NAME)-src-with-data; \
		rm -fr $(INSTALLDIR)/$(NAME)-src-with-data/engine/build; \
	fi
	$(Q)tar -C $(INSTALLDIR) --owner=root --group=root --force-local -cjf $(INSTALLDIR)/$(NAME)-src-with-data.tar.bz2 $(NAME)-src-with-data
	$(Q)rm -rf $(INSTALLDIR)/$(NAME)-src-with-data

distdata-clean:
	$(Q)rm -rf $(INSTALLDIR)/$(NAME)-src-with-data/
	$(Q)rm -f $(INSTALLDIR)/$(NAME)-src-with-data.tar.bz2

=== engine/Makefile ===
#
# Turtle Arena Makefile
#
# GNU Make required
#

# ioq3ztm svn version that this is based on
IOQ3ZTM_REVISION = 113

COMPILE_PLATFORM=$(shell uname|sed -e s/_.*//|tr '[:upper:]' '[:lower:]'|sed -e 's/\//_/g')

COMPILE_ARCH=$(shell uname -m | sed -e s/i.86/i386/)

ifeq ($(COMPILE_PLATFORM),sunos)
  # Solaris uname and GNU uname differ
  COMPILE_ARCH=$(shell uname -p | sed -e s/i.86/i386/)
endif
ifeq ($(COMPILE_PLATFORM),darwin)
  # Apple does some things a little differently...
  COMPILE_ARCH=$(shell uname -p | sed -e s/i.86/i386/)
endif

ifeq ($(COMPILE_PLATFORM),mingw32)
  ifeq ($(COMPILE_ARCH),i386)
    COMPILE_ARCH=x86
  endif
  ifeq ($(COMPILE_ARCH),x86_64)
    COMPILE_ARCH=x64
  endif
endif

ifndef BUILD_CLIENT
  BUILD_CLIENT     =
endif
ifndef BUILD_CLIENT_SMP
  BUILD_CLIENT_SMP =
endif
ifndef BUILD_SERVER
  BUILD_SERVER     =
endif
ifndef BUILD_GAME_SO
  BUILD_GAME_SO    =
endif
ifndef BUILD_GAME_QVM
  BUILD_GAME_QVM   =
endif
ifndef BUILD_BASEGAME
  BUILD_BASEGAME =
endif
ifndef BUILD_MISSIONPACK
  BUILD_MISSIONPACK=0
endif
ifndef BUILD_FINAL
  BUILD_FINAL      =0
endif

ifneq ($(PLATFORM),darwin)
  BUILD_CLIENT_SMP = 0
endif


###################################################################
# Default Turtle Arena config
#  - All of this can be overriden by Makefile.local
###################################################################

# Some of the defines aren't as independent as they should be, TA_WEAPSYS requires TA_PLAYERSYS, etc
# Please note: TA_*SYS defines are general system changes, not 'totally' specifiy for Turtle Arena

##### ioquake3 defines
# RAVENMD4				Enable support for loading MDR models.
# MISSIONPACK			Code for the official Quake III Arena expansion pack, Quake III: Team Arena.
##### Split from MISSIONPACK define
# MISSIONPACK_HUD		Use MISSIONPACK UI scripting in cgame for hud and menus.
# MISSIONPACK_HARVESTER	Enable MISSIONPACK harvester gametype


# Turtle Arena "general" defines
#####
# IOQ3ZTM				ZTurtleMan's misc changes and fixes to ioquake3 (might be q3 mod compatible)
# IOQ3ZTM_NO_COMPAT		Changes that are not compatible with quake3 mods
#
#   DAMAGE_SKINS; Allows player skins to have shaders to use when damaged.
#       Adds a new var "skinFraction" to entityState_t and refEntity_t
#
# IOQ3ZTM_NO_TEAM_MODEL	Removes team_model and team_headmodel cvars. (Could break Quake III: Team Arena and other mods?)
#####
# NOTRATEDM				Disable stuff in Quake3 engine that made it rated M. (default blood to off, remove gibs,
#							remove strong lang) This however doesn't change the gamedata, like the botfiles strong lang,
#							bloody textures, netgamers, etc NOTE: This can be defined without defining "NOBLOOD"
#							ZTM: TODO: Rename this define to ...?
# NOBLOOD				Removes blood. If this is defined, NOTRATEDM must also be defined.
# TA_BLOOM				Post-process bloom light effect, based on code from OpenArena.
#####
# TA_ITEMSYS			Load items from external text files. Required for TA_WEAPSYS.
# TA_ITEMSYS_USE_INTERNAL Use the internal item data. The data can be overriden by external items.
# TA_WEAPSYS			This is the core changes to the weapon system
#							loads the weapons from a text file, allowing for easy modifing,
#							and new custom default weapons for players.
# TA_WEAPSYS_EX			Changes from holding multiple weapons to only one default and one pickup.
# TA_WEAPSYS_EX_COMPAT	Keeps compatibility with mods not using TA_WEAPSYS_EX
# TA_GAME_MODELS		Allow "game" to use model tags. Player tags are used for melee weapon attacking.
# TA_HOLDSYS			Allow players to hold multiple holdable items and change to any holdable.
#							(Based on Q3's weapon changing)
# TA_PLAYERSYS			Allows player config to be used in "game", allowing for per-player settings.
# TA_PATHSYS			General path system using entities like path_corner
# TA_ENTSYS				Adds new entities and allows all ET_MOVER entities to be breakable.
# TA_NPCSYS   			WIP NPC system, based on TDC_NPC system and code in Quake3
# TA_ATMEFFECTS			TODO: Atmospheric effects.
# TA_SUPPORTQ3			Support falling back to Quake3 player tags, shader names, and stuff...
#							Currently required as my players use Q3 tag_weapon instead of Turtle Arena tag_hand_primary...
# TA_SPLITVIEW			Allow a single game client to connect and play using multiple local clients, commonly called splitscreen.
#						TODO: Split view system for viewing multiple network clients at once.


# Turtle Arena specific defines
#####
# TURTLEARENA			Turtle Arena game logic changes
# TA_MISC				Stuff that I don't want in ioq3ztm, but would use in another standalone mod
#							(Like a NiGHTS into Dreams clone or Sonic Robo Blast Arena...)
# TA_SP					Single player / co-op mode code
# TA_DATA				Changes for Turtle Arena data.
#####
# NIGHTSMODE			Hardly started NiGHTS into Dreams mode.

BUILD_DEFINES = -DNOTRATEDM -DNOBLOOD \
					-DIOQ3ZTM -DIOQ3ZTM_NO_COMPAT -DIOQ3ZTM_NO_TEAM_MODEL \
					-DTA_HOLDSYS -DTA_ITEMSYS \
					-DTA_WEAPSYS -DTA_PLAYERSYS \
					-DTA_SUPPORTQ3 -DTA_ENTSYS -DTA_NPCSYS -DTA_PATHSYS \
					-DTA_WEAPSYS_EX_COMPAT \
					-DTA_BLOOM -DTA_SPLITVIEW

BUILD_DEFINES += -DTURTLEARENA -DTA_MISC -DTA_SP \
					-DTA_WEAPSYS_EX -DTA_DATA \
					-DNIGHTSMODE

# Use model tags for true melee attacking
DED_USE_MODELS=1
BUILD_DEFINES += -DTA_GAME_MODELS

# Turtle Arena's intro video will be ogg theora
USE_CODEC_THEORA=1

# Turtle Arena currently just keeps renderer internal
ifneq ($(USE_RENDERER_DLOPEN), 1)
	USE_RENDERER_DLOPEN=0
endif

#############################################################################
#
# If you require a different configuration from the defaults below, create a
# new file named "Makefile.local" in the same directory as this file and define
# your parameters there. This allows you to change configuration without
# causing problems with keeping up to date with the repository.
#
#############################################################################
-include Makefile.local

ifndef PLATFORM
PLATFORM=$(COMPILE_PLATFORM)
endif
export PLATFORM

ifeq ($(COMPILE_ARCH),powerpc)
  COMPILE_ARCH=ppc
endif
ifeq ($(COMPILE_ARCH),powerpc64)
  COMPILE_ARCH=ppc64
endif

ifndef ARCH
ARCH=$(COMPILE_ARCH)
endif
export ARCH

ifneq ($(PLATFORM),$(COMPILE_PLATFORM))
  CROSS_COMPILING=1
else
  CROSS_COMPILING=0

  ifneq ($(ARCH),$(COMPILE_ARCH))
    CROSS_COMPILING=1
  endif
endif
export CROSS_COMPILING

ifndef VERSION
VERSION=0.6.1
endif

ifndef CLIENTBIN
CLIENTBIN=turtlearena
endif

ifndef SERVERBIN
SERVERBIN=turtlearena-server
endif

ifndef BASEGAME
BASEGAME=base
endif

ifndef BASEGAME_CFLAGS
BASEGAME_CFLAGS=-DMISSIONPACK
endif

ifndef MISSIONPACK
MISSIONPACK=missionpack
endif

ifndef MISSIONPACK_CFLAGS
MISSIONPACK_CFLAGS=-DMISSIONPACK -DMISSIONPACK_HUD # -DMISSIONPACK_HARVESTER
endif

# Add "-DEXAMPLE" to define EXAMPLE in engine and game/cgame/ui.
ifndef BUILD_DEFINES
BUILD_DEFINES =
endif

ifndef COPYDIR
COPYDIR="/usr/local/games/turtlearena"
endif

ifndef COPYBINDIR
COPYBINDIR=$(COPYDIR)
endif

ifndef MOUNT_DIR
MOUNT_DIR=code
endif

ifndef BUILD_DIR
BUILD_DIR=build
endif

ifndef TEMPDIR
TEMPDIR=/tmp
endif

ifndef GENERATE_DEPENDENCIES
GENERATE_DEPENDENCIES=1
endif

ifndef USE_OPENAL
USE_OPENAL=1
endif

ifndef USE_OPENAL_DLOPEN
USE_OPENAL_DLOPEN=1
endif

ifndef USE_CURL
USE_CURL=1
endif

ifndef USE_CURL_DLOPEN
  ifeq ($(PLATFORM),mingw32)
    USE_CURL_DLOPEN=0
  else
    USE_CURL_DLOPEN=1
  endif
endif

ifndef USE_CODEC_VORBIS
USE_CODEC_VORBIS=1
endif

ifndef USE_CODEC_THEORA
USE_CODEC_THEORA=0
endif

ifndef USE_MUMBLE
USE_MUMBLE=1
endif

ifndef USE_VOIP
USE_VOIP=1
endif

ifndef USE_INTERNAL_SPEEX
USE_INTERNAL_SPEEX=1
endif

ifndef USE_INTERNAL_ZLIB
USE_INTERNAL_ZLIB=1
endif

ifndef USE_INTERNAL_JPEG
USE_INTERNAL_JPEG=1
endif

ifndef USE_INTERNAL_FREETYPE
USE_INTERNAL_FREETYPE=1
endif

ifndef USE_LOCAL_HEADERS
USE_LOCAL_HEADERS=1
endif

ifndef USE_RENDERER_DLOPEN
USE_RENDERER_DLOPEN=1
endif

ifndef DEBUG_CFLAGS
DEBUG_CFLAGS=-g -O0
endif

ifndef USE_OLD_VM64
USE_OLD_VM64=0
endif

#############################################################################

BD=$(BUILD_DIR)/debug-$(PLATFORM)-$(ARCH)
BR=$(BUILD_DIR)/release-$(PLATFORM)-$(ARCH)
CDIR=$(MOUNT_DIR)/client
SDIR=$(MOUNT_DIR)/server
RDIR=$(MOUNT_DIR)/renderer
CMDIR=$(MOUNT_DIR)/qcommon
SDLDIR=$(MOUNT_DIR)/sdl
ASMDIR=$(MOUNT_DIR)/asm
SYSDIR=$(MOUNT_DIR)/sys
GDIR=$(MOUNT_DIR)/game
CGDIR=$(MOUNT_DIR)/cgame
BLIBDIR=$(MOUNT_DIR)/botlib
NDIR=$(MOUNT_DIR)/null
UIDIR=$(MOUNT_DIR)/ui
Q3UIDIR=$(MOUNT_DIR)/q3_ui
JPDIR=$(MOUNT_DIR)/jpeg-8c
SPEEXDIR=$(MOUNT_DIR)/libspeex
ZDIR=$(MOUNT_DIR)/zlib
FTDIR=$(MOUNT_DIR)/freetype-2.4.9
Q3ASMDIR=$(MOUNT_DIR)/tools/asm
LBURGDIR=$(MOUNT_DIR)/tools/lcc/lburg
Q3CPPDIR=$(MOUNT_DIR)/tools/lcc/cpp
Q3LCCETCDIR=$(MOUNT_DIR)/tools/lcc/etc
Q3LCCSRCDIR=$(MOUNT_DIR)/tools/lcc/src
LOKISETUPDIR=misc/setup
NSISDIR=misc/nsis
SDLHDIR=$(MOUNT_DIR)/SDL12
LIBSDIR=$(MOUNT_DIR)/libs
OGGDIR=$(MOUNT_DIR)/libogg
VORBISDIR=$(MOUNT_DIR)/libvorbis
THEORADIR=$(MOUNT_DIR)/libtheora

bin_path=$(shell which $(1) 2> /dev/null)

# We won't need this if we only build the server
ifneq ($(BUILD_CLIENT),0)
  # set PKG_CONFIG_PATH to influence this, e.g.
  # PKG_CONFIG_PATH=/opt/cross/i386-mingw32msvc/lib/pkgconfig
  ifneq ($(call bin_path, pkg-config),)
    CURL_CFLAGS=$(shell pkg-config --silence-errors --cflags libcurl)
    CURL_LIBS=$(shell pkg-config --silence-errors --libs libcurl)
    OPENAL_CFLAGS=$(shell pkg-config --silence-errors --cflags openal)
    OPENAL_LIBS=$(shell pkg-config --silence-errors --libs openal)
    SDL_CFLAGS=$(shell pkg-config --silence-errors --cflags sdl|sed 's/-Dmain=SDL_main//')
    SDL_LIBS=$(shell pkg-config --silence-errors --libs sdl)
    FREETYPE_CFLAGS=$(shell pkg-config --silence-errors --cflags freetype2)
  endif
  # Use sdl-config if all else fails
  ifeq ($(SDL_CFLAGS),)
    ifneq ($(call bin_path, sdl-config),)
      SDL_CFLAGS=$(shell sdl-config --cflags)
      SDL_LIBS=$(shell sdl-config --libs)
    endif
  endif
endif

ifneq ($(BUILD_FINAL),1)
	# Add svn version info
	USE_SVN=
	ifeq ($(wildcard .svn),.svn)
	  SVN_REV=$(shell LANG=C svnversion .)
	  ifneq ($(SVN_REV),)
		VERSION:=$(VERSION)_SVN$(SVN_REV)
		USE_SVN=1
	  endif
	else
	ifeq ($(wildcard .git/svn/.metadata),.git/svn/.metadata)
	  SVN_REV=$(shell LANG=C git svn info | awk '$$1 == "Revision:" {print $$2; exit 0}')
	  ifneq ($(SVN_REV),)
		VERSION:=$(VERSION)_SVN$(SVN_REV)
	  endif
	endif
	endif

	ifdef IOQ3ZTM_REVISION
	  VERSION:=$(VERSION)_IOQ3ZTMr$(IOQ3ZTM_REVISION)
	endif
endif


#############################################################################
# SETUP AND BUILD -- LINUX
#############################################################################

## Defaults
LIB=lib

INSTALL=install
MKDIR=mkdir

ifneq (,$(findstring "$(PLATFORM)", "linux" "gnu_kfreebsd" "kfreebsd-gnu"))

  ifeq ($(ARCH),axp)
    ARCH=alpha
  else
  ifeq ($(ARCH),x86_64)
    LIB=lib64
  else
  ifeq ($(ARCH),ppc64)
    LIB=lib64
  else
  ifeq ($(ARCH),s390x)
    LIB=lib64
  endif
  endif
  endif
  endif

  BASE_CFLAGS = -Wall -fno-strict-aliasing -Wimplicit -Wstrict-prototypes \
    -pipe -DUSE_ICON
  CLIENT_CFLAGS += $(SDL_CFLAGS)

  OPTIMIZEVM = -O3 -funroll-loops -fomit-frame-pointer
  OPTIMIZE = $(OPTIMIZEVM) -ffast-math

  ifeq ($(ARCH),x86_64)
    OPTIMIZEVM = -O3 -fomit-frame-pointer -funroll-loops \
      -falign-loops=2 -falign-jumps=2 -falign-functions=2 \
      -fstrength-reduce
    OPTIMIZE = $(OPTIMIZEVM) -ffast-math
    HAVE_VM_COMPILED = true
  else
  ifeq ($(ARCH),i386)
    OPTIMIZEVM = -O3 -march=i586 -fomit-frame-pointer \
      -funroll-loops -falign-loops=2 -falign-jumps=2 \
      -falign-functions=2 -fstrength-reduce
    OPTIMIZE = $(OPTIMIZEVM) -ffast-math
    HAVE_VM_COMPILED=true
  else
  ifeq ($(ARCH),ppc)
    BASE_CFLAGS += -maltivec
    HAVE_VM_COMPILED=true
  endif
  ifeq ($(ARCH),ppc64)
    BASE_CFLAGS += -maltivec
    HAVE_VM_COMPILED=true
  endif
  ifeq ($(ARCH),sparc)
    OPTIMIZE += -mtune=ultrasparc3 -mv8plus

=== engine/code/bspc/Makefile ===
#
# Makefile for the BSPC tool for the Gladiator Bot
#
# GNU Make required
#

COMPILE_PLATFORM=$(shell uname|sed -e s/_.*//|tr '[:upper:]' '[:lower:]')

COMPILE_ARCH=$(shell uname -m | sed -e s/i.86/i386/)

ifeq ($(COMPILE_PLATFORM),sunos)
  # Solaris uname and GNU uname differ
  COMPILE_ARCH=$(shell uname -p | sed -e s/i.86/i386/)
endif
ifeq ($(COMPILE_PLATFORM),darwin)
  # Apple does some things a little differently...
  COMPILE_ARCH=$(shell uname -p | sed -e s/i.86/i386/)
endif

ifeq ($(COMPILE_PLATFORM),mingw32)
  ifeq ($(COMPILE_ARCH),i386)
    COMPILE_ARCH=x86
  endif
  ifeq ($(COMPILE_ARCH),x86_64)
    COMPILE_ARCH=x64
  endif
endif


#############################################################################
#
# If you require a different configuration from the defaults below, create a
# new file named "Makefile.local" in the same directory as this file and define
# your parameters there. This allows you to change configuration without
# causing problems with keeping up to date with the repository.
#
#############################################################################
-include Makefile.local

ifndef PLATFORM
PLATFORM=$(COMPILE_PLATFORM)
endif
export PLATFORM

ifeq ($(COMPILE_ARCH),powerpc)
  COMPILE_ARCH=ppc
endif
ifeq ($(COMPILE_ARCH),powerpc64)
  COMPILE_ARCH=ppc64
endif

ifndef ARCH
ARCH=$(COMPILE_ARCH)
endif
export ARCH

ifneq ($(PLATFORM),$(COMPILE_PLATFORM))
  CROSS_COMPILING=1
else
  CROSS_COMPILING=0

  ifneq ($(ARCH),$(COMPILE_ARCH))
    CROSS_COMPILING=1
  endif
endif
export CROSS_COMPILING

ifndef MOUNT_DIR
MOUNT_DIR=..
endif

ifndef BUILD_DIR
BUILD_DIR=../../build
endif

ifndef USE_INTERNAL_ZLIB
USE_INTERNAL_ZLIB=1
endif

ifndef USE_LOCAL_HEADERS
USE_LOCAL_HEADERS=1
endif

#############################################################################

BD=$(BUILD_DIR)/bspc-debug-$(PLATFORM)-$(ARCH)
BR=$(BUILD_DIR)/bspc-release-$(PLATFORM)-$(ARCH)

BLIBDIR=$(MOUNT_DIR)/botlib
BSPCDIR=$(MOUNT_DIR)/bspc
CMDIR=$(MOUNT_DIR)/qcommon
ZDIR=$(MOUNT_DIR)/zlib

bin_path=$(shell which $(1) 2> /dev/null)

ifeq ($(V),1)
echo_cmd=@:
Q=
else
echo_cmd=@echo
Q=@
endif

define DO_CC
$(echo_cmd) "CC $<"
$(Q)$(CC) $(CFLAGS) -o $@ -c $<
endef

ifeq ($(USE_INTERNAL_ZLIB),1)
  BASE_CFLAGS += -DNO_GZIP
  BASE_CFLAGS += -I$(ZDIR)
else
  LIBS += -lz
endif

ifeq ($(USE_LOCAL_HEADERS),1)
  BASE_CFLAGS += -DUSE_LOCAL_HEADERS
endif

TARGETS=$(B)/bspc.$(ARCH)$(BINEXT)

BASE_CFLAGS+=-DCom_Memcpy=memcpy -DCom_Memset=memset

#############################################################################
# SETUP AND BUILD -- Linux
#############################################################################

## Defaults
LIB=lib

INSTALL=install
MKDIR=mkdir

ifeq ($(PLATFORM),linux)

  BASE_CFLAGS+= -Dstricmp=strcasecmp -DLINUX -DBSPC -Wall

  ifeq ($(ARCH),alpha)
    ARCH=axp
  endif

  ifeq ($(ARCH),i386)
    # linux32 make ...
    BASE_CFLAGS += -m32
  else
  ifeq ($(ARCH),ppc64)
    BASE_CFLAGS += -m64
  endif
  endif

  #use these cflags to optimize it
  RELEASE_CFLAGS=$(BASE_CFLAGS) -O6 -ffast-math -funroll-loops \
	-fomit-frame-pointer -fexpensive-optimizations -falign-loops=2 \
	-falign-jumps=2 -falign-functions=2

  #use these when debugging
  DEBUG_CFLAGS=$(BASE_CFLAGS) -g

  LIBS=-lm -lpthread

else # ifeq Linux

#############################################################################
# SETUP AND BUILD -- MAC OS X
#############################################################################

ifeq ($(PLATFORM),darwin)

else # ifeq darwin


#############################################################################
# SETUP AND BUILD -- MINGW32
#############################################################################

ifeq ($(PLATFORM),mingw32)

  # Some MinGW installations define CC to cc, but don't actually provide cc,
  # so explicitly use gcc instead (which is the only option anyway)
  ifeq ($(call bin_path, $(CC)),)
    CC=gcc
  endif

  ifndef WINDRES
    WINDRES=windres
  endif

  BINEXT=.exe

  BASE_CFLAGS+= -DBSPC -Wall
  ifeq ($(ARCH),x86)
    # build 32bit
    BASE_CFLAGS += -m32
  else
    BASE_CFLAGS += -m64
  endif

  # In the absence of wspiapi.h, require Windows XP or later
  ifeq ($(shell test -e $(CMDIR)/wspiapi.h; echo $$?),1)
    BASE_CFLAGS += -DWINVER=0x501
  endif

  CFLAGS=$(BASE_CFLAGS)

  LDFLAGS=-lws2_32 -lwinmm -mwindows

else # ifeq mingw32

#############################################################################
# SETUP AND BUILD -- FREEBSD
#############################################################################

ifeq ($(PLATFORM),freebsd)

  ifneq (,$(findstring alpha,$(shell uname -m)))
    ARCH=axp
  else #default to i386
    ARCH=i386
  endif #alpha test

else # ifeq freebsd

#############################################################################
# SETUP AND BUILD -- OPENBSD
#############################################################################

ifeq ($(PLATFORM),openbsd)

  #default to i386, no tests done on anything else
  ARCH=i386

else # ifeq openbsd

#############################################################################
# SETUP AND BUILD -- NETBSD
#############################################################################

ifeq ($(PLATFORM),netbsd)

  ifeq ($(shell uname -m),i386)
    ARCH=i386
  endif

else # ifeq netbsd

#############################################################################
# SETUP AND BUILD -- IRIX
#############################################################################

ifeq ($(PLATFORM),irix64)

  ARCH=mips  #default to MIPS

  CC = c99
  MKDIR = mkdir -p

else # ifeq IRIX

#############################################################################
# SETUP AND BUILD -- SunOS
#############################################################################

ifeq ($(PLATFORM),sunos)

  CC=gcc
  INSTALL=ginstall
  MKDIR=gmkdir

  ifneq (,$(findstring i86pc,$(shell uname -m)))
    ARCH=i386
  else #default to sparc
    ARCH=sparc
  endif

else # ifeq sunos

#############################################################################
# SETUP AND BUILD -- GENERIC
#############################################################################

endif #Linux
endif #darwin
endif #mingw32
endif #FreeBSD
endif #OpenBSD
endif #NetBSD
endif #IRIX
endif #SunOS

#############################################################################
# MAIN TARGETS
#############################################################################

default: release
all: debug release

debug:
	@$(MAKE) targets B=$(BD) CFLAGS="$(CFLAGS) $(DEPEND_CFLAGS) \
		$(DEBUG_CFLAGS)" V=$(V)

release:
	@$(MAKE) targets B=$(BR) CFLAGS="$(CFLAGS) $(DEPEND_CFLAGS) \
		$(RELEASE_CFLAGS)" V=$(V)

# Create the build directories, check libraries and print out
# an informational message, then start building
targets: makedirs
	@echo ""
	@echo "Building bspc in $(B):"
	@echo "  PLATFORM: $(PLATFORM)"
	@echo "  ARCH: $(ARCH)"
	@echo "  COMPILE_PLATFORM: $(COMPILE_PLATFORM)"
	@echo "  COMPILE_ARCH: $(COMPILE_ARCH)"
	@echo "  CC: $(CC)"
	@echo ""
	@echo "  CFLAGS:"
	-@for i in $(CFLAGS); \
	do \
		echo "    $$i"; \
	done
	@echo ""
	@echo "  LDFLAGS:"
	-@for i in $(LDFLAGS); \
	do \
		echo "    $$i"; \
	done
	@echo ""
	@echo "  LIBS:"
	-@for i in $(LIBS); \
	do \
		echo "    $$i"; \
	done
	@echo ""
	@echo "  Output:"
	-@for i in $(TARGETS); \
	do \
		echo "    $$i"; \
	done
	@echo ""
ifneq ($(TARGETS),)
	@$(MAKE) $(TARGETS) V=$(V)
endif

makedirs:
	@if [ ! -d $(BUILD_DIR) ];then $(MKDIR) $(BUILD_DIR);fi
	@if [ ! -d $(B) ];then $(MKDIR) $(B);fi
	@if [ ! -d $(B)/bspc ];then $(MKDIR) $(B)/bspc;fi
	@if [ ! -d $(B)/botlib ];then $(MKDIR) $(B)/botlib;fi
	@if [ ! -d $(B)/qcommon ];then $(MKDIR) $(B)/qcommon;fi
	@if [ ! -d $(B)/zlib ];then $(MKDIR) $(B)/zlib;fi

#############################################################################
# BUILD BSPC
#############################################################################

$(B)/botlib/%.o: $(BLIBDIR)/%.c
	$(DO_CC)
$(B)/bspc/%.o: $(BSPCDIR)/%.c
	$(DO_CC)
$(B)/qcommon/%.o: $(CMDIR)/%.c
	$(DO_CC)
$(B)/zlib/%.o: $(ZDIR)/%.c
	$(DO_CC)

BSPC_OBJS = \
	$(B)/bspc/aas_areamerging.o\
	$(B)/bspc/aas_cfg.o\
	$(B)/bspc/aas_create.o\
	$(B)/bspc/aas_edgemelting.o\
	$(B)/bspc/aas_facemerging.o\
	$(B)/bspc/aas_file.o\
	$(B)/bspc/aas_gsubdiv.o\
	$(B)/bspc/aas_map.o\
	$(B)/bspc/aas_prunenodes.o\
	$(B)/bspc/aas_store.o\
	$(B)/bspc/be_aas_bspc.o\
	$(B)/botlib/be_aas_bspq3.o\
	$(B)/botlib/be_aas_cluster.o\
	$(B)/botlib/be_aas_move.o\
	$(B)/botlib/be_aas_optimize.o\
	$(B)/botlib/be_aas_reach.o\
	$(B)/botlib/be_aas_sample.o\
	$(B)/bspc/brushbsp.o\
	$(B)/bspc/bspc.o\
	$(B)/qcommon/cm_load.o\
	$(B)/qcommon/cm_patch.o\
	$(B)/qcommon/cm_test.o\
	$(B)/qcommon/cm_trace.o\
	$(B)/bspc/csg.o\
	$(B)/bspc/glfile.o\
	$(B)/bspc/l_bsp_ent.o\
	$(B)/bspc/l_bsp_hl.o\
	$(B)/bspc/l_bsp_q1.o\
	$(B)/bspc/l_bsp_q2.o\
	$(B)/bspc/l_bsp_q3.o\
	$(B)/bspc/l_bsp_sin.o\
	$(B)/bspc/l_cmd.o\
	$(B)/botlib/l_libvar.o\
	$(B)/bspc/l_log.o\
	$(B)/bspc/l_math.o\
	$(B)/bspc/l_mem.o\
	$(B)/bspc/l_poly.o\
	$(B)/botlib/l_precomp.o\
	$(B)/bspc/l_qfiles.o\
	$(B)/botlib/l_script.o\
	$(B)/botlib/l_struct.o\
	$(B)/bspc/l_threads.o\
	$(B)/bspc/l_utils.o\
	$(B)/bspc/leakfile.o\
	$(B)/bspc/map.o\
	$(B)/bspc/map_hl.o\
	$(B)/bspc/map_q1.o\
	$(B)/bspc/map_q2.o\
	$(B)/bspc/map_q3.o\
	$(B)/bspc/map_sin.o\
	$(B)/qcommon/md4.o\
	$(B)/bspc/nodraw.o\
	$(B)/bspc/portals.o\
	$(B)/bspc/textures.o\
	$(B)/bspc/tree.o\
	$(B)/qcommon/ioapi.o\
	$(B)/qcommon/unzip.o

        #tetrahedron.o

ifeq ($(USE_INTERNAL_ZLIB),1)
BSPC_OBJS += \
  $(B)/zlib/adler32.o \
  $(B)/zlib/crc32.o \
  $(B)/zlib/inffast.o \
  $(B)/zlib/inflate.o \
  $(B)/zlib/inftrees.o \
  $(B)/zlib/zutil.o
endif

$(B)/bspc.$(ARCH)$(BINEXT) : $(BSPC_OBJS)
	$(echo_cmd) "LD $@"
	$(Q)$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $(BSPC_OBJS) $(LIBS)

#############################################################################
# MISC
#############################################################################

OBJ=$(BSPC_OBJS)
OBJ_D_FILES=$(filter %.d,$(OBJ:%.o=%.d))

clean: clean-debug clean-release

clean-debug:
	@$(MAKE) clean2 B=$(BD)

clean-release:
	@$(MAKE) clean2 B=$(BR)

clean2:
	@echo "CLEAN $(B)"
	@rm -f $(OBJ)
	@rm -f $(OBJ_D_FILES)
	@rm -f $(TARGETS)

depend:
	$(echo_cmd) "DEPEND $(B)"
	$(Q)$(CC) -MM $(BSPC_OBJS:.o=.c)

# Copy to main directory
install:
	cp $(BR)/bspc.$(ARCH)$(BINEXT) $(BSPCDIR)/../../../

=== engine/misc/nsis/Makefile ===
COMPILE_PLATFORM=$(shell uname|sed -e s/_.*//|tr '[:upper:]' '[:lower:]'|sed -e 's/\//_/g')

ifndef VERSION
VERSION=0.6.1
endif
ifndef RELEASE
RELEASE=0
endif
ifndef ARCH
ARCH=x86
endif
ifndef ASSETPATH
ASSETPATH=.
endif
ifndef INSTALLDIR
INSTALLDIR=.
endif
ifndef USE_RENDERER_DLOPEN
USE_RENDERER_DLOPEN=0
endif
ifndef USE_OPENAL_DLOPEN
USE_OPENAL_DLOPEN=1
endif
ifndef USE_CURL_DLOPEN
USE_CURL_DLOPEN=0
endif
ifndef USE_INTERNAL_SPEEX
USE_INTERNAL_SPEEX=1
endif
ifndef USE_INTERNAL_ZLIB
USE_INTERNAL_ZLIB=1
endif
ifndef USE_INTERNAL_JPEG
USE_INTERNAL_JPEG=1
endif

SDLDLL=SDL.dll

DEFINES=
ifeq ($(USE_RENDERER_DLOPEN),1)
	DEFINES+= -DUSE_RENDERER_DLOPEN
endif
ifeq ($(USE_OPENAL_DLOPEN),1)
	DEFINES+= -DUSE_OPENAL_DLOPEN
endif
ifeq ($(USE_CURL_DLOPEN),1)
	DEFINES+= -DUSE_CURL_DLOPEN
endif
ifeq ($(USE_INTERNAL_SPEEX),1)
	DEFINES+= -DUSE_INTERNAL_SPEEX
endif
ifeq ($(USE_INTERNAL_ZLIB),1)
	DEFINES+= -DUSE_INTERNAL_ZLIB
endif
ifeq ($(USE_INTERNAL_JPEG),1)
	DEFINES+= -DUSE_INTERNAL_JPEG
endif


all: turtlearena-$(VERSION)-$(RELEASE).$(ARCH).exe

turtlearena.$(ARCH).nsi: turtlearena.nsi.in
	sed 's|XXXVERSIONXXX|$(VERSION)|;s|XXXRELEASEXXX|$(RELEASE)|;s|x86|$(ARCH)|g;s|XXXASSETPATHXXX|$(ASSETPATH)|;s|SDL.dll|$(SDLDLL)|' < $< > $@

turtlearena-$(VERSION)-$(RELEASE).$(ARCH).exe: turtlearena.$(ARCH).nsi
	cp "../../../GPL-2.txt" .
	cp "../../../CC-BY-SA-3.0.txt" .
	cp "../../../COPYRIGHTS.txt" .
	cp "../../../CREDITS.txt" .
	cp "../../../INSTALLER_README.txt" "README.txt"
ifneq ($(COMPILE_PLATFORM),mingw32)
	todos GPL-2.txt
	todos CC-BY-SA-3.0.txt
	todos COPYRIGHTS.txt
	todos CREDITS.txt
	todos README.txt
endif
	makensis $(DEFINES) turtlearena.$(ARCH).nsi

clean:
	rm -rf *.exe turtlearena.$(ARCH).nsi GPL-2.txt CC-BY-SA-3.0.txt COPYRIGHTS.txt CREDITS.txt README.txt

install:
	mkdir -p $(INSTALLDIR)
	mv turtlearena-$(VERSION)-$(RELEASE).$(ARCH).exe $(INSTALLDIR)

.PHONY: all clean

=== engine/misc/setup/Makefile ===
ifndef VERSION
VERSION=0.6.1
endif
ifndef RELEASE
RELEASE=0
endif

all:
	VERSION=$(VERSION) RELEASE=$(RELEASE) ./doit

sign:
	for i in *.run; do \
		gpg -bao $$i.asc $$i; \
	done

clean:
	rm -rf *.run image defines.m4

.PHONY: all sign clean

=== debian_main/data/debian/changelog ===
turtlearena-data (0.6.1-1~lucid1) lucid; urgency=low

  * New upstream release.

 -- Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>  Tue, 14 Aug 2012 16:07:52 +0600

turtlearena-data (0.6-1~lucid1) lucid; urgency=low

  * New upstream release.

 -- Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>  Mon, 9 Apr 2012 15:07:04 +0600

turtlearena-data (0.5.3-1~lucid1) lucid; urgency=low

  * New upstream release.

 -- Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>  Fri, 23 Dec 2011 12:17:56 +0600

turtlearena-data (0.5.2-1~lucid1) lucid; urgency=low

  * New upstream release.

 -- Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>  Sat, 14 Aug 2011 18:36:22 +0500

turtlearena-data (0.5.1-1~lucid1) lucid; urgency=low

  * New upstream release.

 -- Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>  Sat, 30 Jul 2011 20:24:33 +0500

turtlearena-data (0.5.0-1~lucid1) lucid; urgency=low

  * New upstream release.

 -- Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>  Tue, 9 Mar 2011 22:19:59 +0500

turtlearena-data (0.5.0-0~lucid1) lucid; urgency=low

  * Development release

 -- Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>  Tue, 9 Mar 2011 22:19:59 +0500

turtlearena-data (0.4.1-1~lucid1) lucid; urgency=low

  * New upstream release.

 -- Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>  Tue, 4 Jan 2011 00:22:23 +0500

turtlearena-data (0.4-1~lucid1) lucid; urgency=low

  * New upstream release.

 -- Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>  Sat, 30 Dec 2010 11:43:20 +0500

turtlearena-data (0.2-1) lucid; urgency=low

  * Initial release

 -- Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>  Fri, 28 May 2010 13:01:28 +0500

=== debian_main/engine/debian/changelog ===
turtlearena (0.6.1-1~lucid1) lucid; urgency=low

  * New upstream release.

 -- Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>  Tue, 14 Aug 2012 16:07:52 +0600

turtlearena (0.6-1~lucid1) lucid; urgency=low

  * New upstream release.

 -- Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>  Mon, 9 Apr 2012 15:07:04 +0600

turtlearena (0.5.3-1~lucid1) lucid; urgency=low

  * New upstream release.

 -- Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>  Fri, 23 Dec 2011 12:17:56 +0600

turtlearena (0.5.2-1~lucid1) lucid; urgency=low

  * New upstream release.

 -- Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>  Sat, 14 Aug 2011 18:36:22 +0500

turtlearena (0.5.1-1~lucid1) lucid; urgency=low

  * New upstream release.

 -- Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>  Sat, 30 Jul 2011 20:24:33 +0500

turtlearena (0.5.0-2~lucid1) lucid; urgency=low

  * New upstream release.

 -- Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>  Tue, 9 Mar 2011 22:19:59 +0500

turtlearena (0.5.0-0~lucid1) lucid; urgency=low

  * Development release

 -- Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>  Tue, 9 Mar 2011 22:19:59 +0500

turtlearena (0.4.1-1~lucid1) lucid; urgency=low

  * New upstream release.

 -- Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>  Tue, 4 Jan 2011 00:22:23 +0500

turtlearena (0.4-1~lucid1) lucid; urgency=low

  * New upstream release.

 -- Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>  Sat, 30 Dec 2010 11:43:20 +0500

turtlearena (0.2-1) lucid; urgency=low

  * Initial release

 -- Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>  Fri, 28 May 2010 13:01:28 +0500

=== debian_main/wiimote/debian/changelog ===
turtlearena-wiimote (0.2-1~lucid1) lucid; urgency=low

  * Initial release

 -- Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>  Fri, 10 Dec 2010 15:41:25 +0500

=== debian_main/data/debian/control ===
Source: turtlearena-data
Section: games
Priority: optional
Maintainer: Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>
Uploaders: Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>
Build-Depends: debhelper (>= 7)
Standards-Version: 3.8.0
Homepage: http://turtlearena.googlecode.com/

Package: turtlearena-data
Architecture: all
Depends: ${misc:Depends}
Recommends: turtlearena (>= ENGINE_VERSION) | turtlearena-server (>= ENGINE_VERSION)
Description: Turtle Arena data files
 Turtle Arena is an free and open source 3D third person action game based on
 ioquake3. It is a free stand-alone game.
 .
 This package installs the Turtle Arena data files required to play the game or run a server.

=== debian_main/engine/debian/control ===
Source: turtlearena
Section: games
Priority: optional
Maintainer: Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>
Uploaders: Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>
Build-Depends: debhelper (>= 5.0.51), libsdl1.2-dev, libopenal-dev, imagemagick, libcurl4-gnutls-dev, libvorbis-dev, libtheora-dev, libspeexdsp-dev, libfreetype6-dev
Standards-Version: 3.8.3
Homepage: http://turtlearena.googlecode.com/

Package: turtlearena
Architecture: any
Depends: ${shlibs:Depends}, turtlearena-data (>= DATA_VERSION)
Recommends: turtlearena-server, turtlearena-wiimote
Description: 3D Third-Person Action Game
 Turtle Arena is an free and open source 3D third person action game based on
 ioquake3. It is a free stand-alone game.
 .
 This package installs the Turtle Arena client.

Package: turtlearena-server
Architecture: any
Depends: ${shlibs:Depends}, turtlearena-data (>= DATA_VERSION)
Description: Dedicated server for Turtle Arena
 Turtle Arena is an free and open source 3D third person action game based on
 ioquake3. It is a free stand-alone game.
 .
 This package installs the Turtle Arena dedicated server.

=== debian_main/wiimote/debian/control ===
Source: turtlearena-wiimote
Section: games
Priority: optional
Maintainer: Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>
Uploaders: Zack "ZTurtleMan" Middleton <ZTurtleMan@gmail.com>
Build-Depends: debhelper (>= 7)
Standards-Version: 3.8.0
Homepage: http://turtlearena.googlecode.com/

Package: turtlearena-wiimote
Architecture: all
Depends: ${misc:Depends}, wminput
Recommends: turtlearena (>= ${source:Upstream-Version})
Description: Turtle Arena Wiimote support
 Turtle Arena is an open-source Ninja Turtle fangame based on ioquake3. It
 is licensed under the GPL. It is a free stand-alone game.
 .
 This package installs the Turtle Arena Wiimote wminput config and launchers.

=== debian_main/engine/debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    MAKEFLAGS += -j$(NUMJOBS)
endif

Q3ARCH             := $(shell sh $(CURDIR)/debian/q3arch.sh arch     HOST)
Q3PLATFORM         := $(shell sh $(CURDIR)/debian/q3arch.sh platform HOST)
Q3COMPILE_ARCH     := $(shell sh $(CURDIR)/debian/q3arch.sh arch     BUILD)
Q3COMPILE_PLATFORM := $(shell sh $(CURDIR)/debian/q3arch.sh platform BUILD)

CFLAGS += -fsigned-char

build: build-stamp
build-stamp:
	dh_testdir
	$(MAKE) USE_CURL=1 \
			USE_CURL_DLOPEN=0 \
			USE_OPENAL=1 \
			USE_OPENAL_DLOPEN=0 \
			USE_VOIP=1 \
			USE_INTERNAL_SPEEX=0 \
			USE_INTERNAL_FREETYPE=0 \
			BUILD_CLIENT=1 \
			BUILD_CLIENT_SMP=0 \
			BUILD_SERVER=1 \
			BUILD_GAME_SO=0 \
			BUILD_GAME_QVM=0 \
			USE_LOCAL_HEADERS=0 \
			BUILD_FINAL=1 \
			DEFAULT_BASEDIR=/usr/share/games/turtlearena \
			ARCH=$(Q3ARCH) \
			PLATFORM=$(Q3PLATFORM) \
			COMPILE_ARCH=$(Q3COMPILE_ARCH) \
			COMPILE_PLATFORM=$(Q3COMPILE_PLATFORM)
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp
	$(MAKE) distclean
	rm -f debian/turtlearena32.xpm
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	mkdir -p debian/tmp
	cp build/release-$(Q3PLATFORM)-$(Q3ARCH)/turtlearena.$(Q3ARCH) debian/tmp/turtlearena
	cp build/release-$(Q3PLATFORM)-$(Q3ARCH)/turtlearena-server.$(Q3ARCH) debian/tmp/turtlearena-server
	convert -scale 32x32 debian/turtlearena128.png debian/turtlearena32.xpm
	dh_install
	dh_installdirs


binary-indep: build install
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installdocs
	dh_link
	dh_installmenu
	dh_installchangelogs
	dh_installman -pturtlearena debian/turtlearena.6
	dh_installman -pturtlearena-server debian/turtlearena-server.6
	dh_icons -pturtlearena
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install
